package hellodigits;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileWriter;

public class DataB 
{
	private Process arrP [];
	private Boolean arrB [];
	public static String arrN[];
	private String arrL[];
	private int size;
	private int index;
	private int countLink;

	public DataB ()
	{	
		size = 10;
		index = countLink = 0;
		arrL = new String[size];
		arrN = new String[size];
		arrB = new Boolean[size];
		arrP = new Process[size];
		for(int i=0; i<size; i++)
		{
			arrB[i] = false;
			arrP[i] = null;
		}

	}
	public void addLink (String name, String link)
	{
		
		if(index >= size)
		{
			size+=10;
			Process tempP[] = new Process[size];
			Boolean tempB[] = new Boolean[size];
			String tempN[] = new String[size];
			String tempL[] = new String[size];

			for(int i=0; i<index; i++)
			{
				tempP[i] = arrP[i];
				tempN[i] = arrN[i];
				tempB[i] = arrB[i];
				tempL[i] = arrL[i];
			}
			arrP = tempP;
			arrB = tempB;
			arrN = tempN;
			arrL = tempL;
		}
		
		arrP[index] = null;
		arrB[index] = false;
		arrN[index] = name;
		arrL[index] = link;
		
		index++;
	}
	public Boolean set(int n, String name, String link)
	{
		if(n<1 || n>index)
			return false;
		if(name=="" && link == "")// case empty
		{
			del(n);
			return true;
		}
		arrN[n-1] = name;
		arrL[n-1] = link;
		for(int i=0; i<index;i++)
			System.out.print(arrN[i]+ "\t");
		return true;
		
	}
	public Boolean del(int n)
	{
		if(n<1 || n>index)
			return false;
		for(int i=n-1; i<index; i++)
		{
			arrP[i] = arrP[i+1];
			arrN[i] = arrN[i+1];
			arrB[i] = arrB[i+1];
			arrL[i] = arrL[i+1];
		}
		arrP[index] = null;
		arrB[index] = false;
		arrN[index] = null;
		arrL[index] = null;
		index--;
		if(size>index +10)
			size-=10;
		return true;
	}
	public void openProcess(int n,Process p)
	{
		arrP[n] = p;
		arrB[n] = true;
	}
	public void closeProcess(int n)
	{
		arrB[n] = false;
	}
	public String getLink(int n)
	{
		return arrL[n];
	}
	public int getSize()
	{
		return index;
	}
	public Boolean isOpen(int n)
	{
		return arrB[n];
	}
	public void destroy(int n)
	{
		arrP[n].destroy();
	}
	public void saveLink()
	{
	    try{
	        // Create file 
	        FileWriter fstream = new FileWriter("links.txt");
	            BufferedWriter out = new BufferedWriter(fstream);
	            for(int i=0; i<index; i++)
	            	if(arrN[i].length()>0 && arrL[i].length()>0)
	            		out.write(arrN[i] + ";" + arrL[i]+"\r\n");
	            	else
	            		out.write(" ; ");
	        //Close the output stream
	        out.close();
	        }catch (Exception e){//Catch exception if any
	          System.err.println("Error: " + e.getMessage());
	        }

	}
	public int upload()
	{
		 try {
			 
		        String sCurrentLine;
		        String name_link[] = new String[2];
			BufferedReader br = new BufferedReader(new FileReader("links.txt"));
		 
		        while ((sCurrentLine = br.readLine()) != null) {
			       name_link = sCurrentLine.split(";");
			       addLink(name_link[0], name_link[1]);
			       //System.out.print("name: " + name_link[0] + "\t" + "link: " + name_link[1] + "\n");
			       countLink++;
		        } 
		        //index = countLink;
		        for(int i=countLink+1; i<size; i++)
		        {
		        	arrP[i]=null;
		        	arrL[i]=null;
		        	arrN[i]=null;
		        	arrB[i]=false;
		        }
		 
		    } catch (FileNotFoundException e) {
		 
		      e.printStackTrace();
		 
		    } catch (IOException e) {
		 
		      e.printStackTrace();
		 
		    }
/*		    ////// full list //////////
		    try{
		        // Create file 
		        FileWriter fstreamList = new FileWriter("C:/Users/Gilad/Desktop/full list.txt");
		            BufferedWriter outList = new BufferedWriter(fstreamList);
		            outList.write("Order: oh oh oh"+"\t"+ "aplication: exit"+"\r\n");
		            for(int j=0; j<countLink; j++)
		            	outList.write("Order: "+ main.numTrans[j+1]+ "\t"+"Application: " + arrN[j] +"\r\n");		            
		        //Close the output stream
		        outList.close();
		        }catch (Exception e){//Catch exception if any
		          System.err.println("Error: " + e.getMessage());
		        }
	*/	    
		    //////////////////////////
		    return countLink;
	}
}
